/*
  FreeRTOS

  FreeRTOSɂ}`^XNB

  EFreeRTOSConfig.hɏݒscortex-m0pɃRpCꂽ
    FreeRTOSNĂ̂ŁAD݂ƈႤꍇ̓Cu̍č\zv
  ESẴ^XNBlockedԂɂȂƐϋɓIɏȓd̓[hɑJڂ
    
  EVXeZbg؂藣ē͒[qɂAPB1ĂԂ̓~[
    ebNXő̃^XNƔr䂷
  ExTaskCreateusStackDepth̒l͌̈ӂɏݒ肵Ă
 */

// FreeRTOS֘Ãwb_
#include  <FreeRTOS.h>
#include  <task.h>
#include  <semphr.h>

#include  <chip.h>
// {[h̒[q蓖Ăƍŏ̏
#include  "e097b_def.h"

// USART_TYPE}NŎgpUSARTƋ@\I
// CN3/CN4     1:|[O, 2:荞, 3:DMA
// CN1-6,CN1-7 4:|[O, 5:荞, 6:DMA
#ifndef USART_TYPE
  #define USART_TYPE 3
#endif
#include  "e097b_usart.h"

#include  <wl_delay.h>

// }NEO[oϐȂ
//-----------------------------
// [qݒ
const TPin pin_pb1[] = {
  { _PB1, PIO_TYPE_INPUT, 0, PIO_MODE_PULLUP },
};

// VAʐMpobt@
uint8_t txb[1000], rxb[1000];

// mutex
SemaphoreHandle_t xMutex = NULL;

// PB
//-----------------------------
bool GetPB (void) {
  return !Chip_GPIO_GetPinState (LPC_GPIO_PORT, 0, _PB1);
}

// ^XN
//-----------------------------
void T1 (void *pvParameters) {
  portTickType t = xTaskGetTickCount ();

  for (;;) {
    xSemaphoreTake (xMutex, portMAX_DELAY);
    xSemaphoreGive (xMutex);

    ToggleLED ();

    vTaskDelayUntil (&t, 200);
  }
}

void T2 (void *pvParameters) {
  portTickType t = xTaskGetTickCount ();

  for (;;) {
    xSemaphoreTake (xMutex, portMAX_DELAY);
    xSemaphoreGive (xMutex);

    us_puts ("*");

    vTaskDelayUntil (&t, 500);
  }
}

void T3 (void *pvParameters) {
  int i, r;
  static uint8_t rbuf[100];

  for (;;) {
    if ((r = us_rx_buff())) {
      for (i = 0; i < r && i < sizeof (rbuf); i++) {
        rbuf[i] = us_getc();
        if (rbuf[i] == '!') NVIC_SystemReset ();
      }
      us_putsb (rbuf, i);
    }
    vTaskDelay (100);
  }
}

void T4 (void *pvParameters) {
  for (;;) {
    xSemaphoreTake (xMutex, portMAX_DELAY);
    while (GetPB ()) ;
    xSemaphoreGive (xMutex);

    vTaskDelay (10);
  }
}

// Stack over flow hook
//-----------------------------------
// X^bNI[o[t[o (mɕ⑫ł킯łȂ)
void vApplicationStackOverflowHook (TaskHandle_t pxTask, char *pcTaskName) {
  taskDISABLE_INTERRUPTS ();

  us_printf ("\nstack overflow(%s)", pcTaskName);

  while (1) {
    // LED̋Pxŕς
    for (int i = 0; i < 500; i++) {
      SetLED (true);
      Delay_us (500 - i);
      SetLED (false);
      Delay_us (i);
    }
    Delay_ms (50);
  }
}

// main
//-----------------------------
void main (void) {
  // PB1̒[q@\̏
  PIO_Configure (pin_pb1, PIO_LISTSIZE (pin_pb1));

  us_init (Chip_Clock_GetFRGClockRate (0), 115200, USIP_8N1, txb, sizeof (txb), rxb, sizeof (rxb));

  // ~[ebNX쐬
  xMutex = xSemaphoreCreateMutex ();

  // ^XN쐬
  xTaskCreate (T1, "T1", 40, NULL, 1, NULL);
  xTaskCreate (T2, "T2", 40, NULL, 1, NULL);
  xTaskCreate (T3, "T3", 40, NULL, 1, NULL);
  xTaskCreate (T4, "T4", 40, NULL, 1, NULL);
  // OS̓Jn
  vTaskStartScheduler();
}
